/*
 * Copyright 2014, 2015 Peter Hansen and İnanç Seylan,
 *           2016, 2017 Peter Hansen.
 * 
 * This file is part of Grind v2.
 * 
 * Grind is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * Grind is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with Grind.  If not, see <http://www.gnu.org/licenses/>.
 */
package de.unibremen.informatik.tdki.grind2.runnables;

/**
 *
 * @author hansen
 */
public class RunAvarReduction {

    /*
    
    static boolean verbose = true;
    static boolean norewrite = false;

    public static void main(String[] args) throws Exception {

        CQContext.getINSTANCE().setVerbose(verbose);
        CQContext.getINSTANCE().setNorewrite(norewrite);

        Variable x0, x1, x01, x2, x3, x4, x5, x6;
        Set<Atom> setOfAtoms;
        Set<Variable> avarSet;
        CQ q0;

        CQContext.refresh();
        CQContext.getINSTANCE().loadFromFile("./ontologies/grind1-test-ontologies/NBO.owl");
        Set<OWLAxiom> axioms = CQContext.getINSTANCE().getOriginalOnt().getGCIsAsAxioms();
        
        Signature sigma = CQContext.getINSTANCE().getOriginalSignature();

        System.out.println(axioms);

        x0 = new Variable(0);
        x1 = new Variable(1);

        OWLClass classicalConditioning = sigma.getCls("0000208");
        OWLClass laughingBehavior = sigma.getCls("0000617");
        OWLObjectProperty isAbout = sigma.getRole("is_about");

        setOfAtoms = new HashSet<>();
        setOfAtoms.add(new ClassAtom(classicalConditioning, x0));
        setOfAtoms.add(new ClassAtom(laughingBehavior, x1));
        setOfAtoms.add(new RoleAtom(isAbout, x0, x1));
        avarSet = Sets.newHashSet(x0, x1);
        q0 = new AvarCQ(avarSet, setOfAtoms);

        System.out.println("\n" + q0 + "\n\n");

        OWLOntology avarRedOnt = CQContext.getINSTANCE().getAvarReductionOntology((AvarCQ) q0);

        // Ok, we have a new ontology T' and a concept name N. 
        // Now start the AQ algorithm!
        GammaAndOmegaCaller caller = new GammaAndOmegaCaller(avarRedOnt);
        caller.runSingleConceptname(CQContext.getINSTANCE().getClsN());

        CQContext.refresh();

        //        CQContext.getINSTANCE().loadFromFile("./cq-ontologies/420-rooted-reduction-test.owl");
        CQContext.getINSTANCE().loadFromFile("./ontologies/grind1-test-ontologies/FBbi.owl");      //    4s
//        CQContext.getINSTANCE().loadFromFile("./ontologies/grind1-test-ontologies/NBO.owl");       //   15s
//        CQContext.getINSTANCE().loadFromFile("./ontologies/grind1-test-ontologies/XP.owl");        //   41s
//        CQContext.getINSTANCE().loadFromFile("./ontologies/grind1-test-ontologies/ENVO.owl");      //   11s
//        CQContext.getINSTANCE().loadFromFile("./ontologies/grind1-test-ontologies/MOHSE.owl");     // 1m16s
//        CQContext.getINSTANCE().loadFromFile("./ontologies/grind1-test-ontologies/not-galen.owl"); // 3m41s
//        CQContext.getINSTANCE().loadFromFile("./ontologies/grind1-test-ontologies/SO.owl");        //   39s

        PrefixManager pm = CQContext.getINSTANCE().getPm();

        OWLObjectProperty roleR = OntologyUtils.createRole("r", pm);
        OWLClass clsA = OntologyUtils.createClass("A", pm);
        OWLClass clsB = OntologyUtils.createClass("B", pm);
        OWLClass clsC = OntologyUtils.createClass("C", pm);
        x0 = new Variable(0);
        x1 = new Variable(1);
        x01 = new Variable(Sets.newHashSet(x0, x1));
        x2 = new Variable(2);
        x3 = new Variable(3);

        setOfAtoms = new HashSet<>();
        setOfAtoms.add(new ClassAtom(clsA, x0));
        setOfAtoms.add(new RoleAtom(roleR, x0, x2));
        setOfAtoms.add(new ClassAtom(clsB, x1));
        setOfAtoms.add(new RoleAtom(roleR, x1, x2));
        setOfAtoms.add(new RoleAtom(roleR, x2, x3));
        setOfAtoms.add(new ClassAtom(clsC, x3));
        avarSet = Sets.newHashSet(x0);
        q0 = new RootedCQ(avarSet, setOfAtoms);

        RCQReductionCaller rCQcaller = new RCQReductionCaller();
        rCQcaller.startReductionFor((RootedCQ) q0);

    }


    */


}
