/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package de.unibremen.informatik.tdki.grind2.datalog;

import de.unibremen.informatik.tdki.grind2.datalog.components.DatalogAtom;
import java.util.Set;

/**
 *
 * @author hansen
 */
public class DatalogRule {

    DatalogAtom headAtom;
    Set<DatalogAtom> body;

    public DatalogRule(DatalogAtom headAtom, Set<DatalogAtom> body) {
        this.headAtom = headAtom;
        this.body = body;
    }

    public Set<DatalogAtom> getBody() {
        return body;
    }

    public DatalogAtom getHeadAtom() {
        return headAtom;
    }

    @Override
    public String toString() {
        String result = headAtom + "  <-  ";
        for (DatalogAtom atom : body) {
            result += atom + ", ";
        }
        // Delete final ", " from result:
        result = result.substring(0, result.length() - 2);
        return result;
    }

}
